	.include	iocscall.mac
	.include	doscall.mac

	.text
program_start:
device_header:
	.dc.l	-1
	.dc.w	$8000
	.dc.l	device_strategy
	.dc.l	device_interrupt
	.dc.b	"*DEVEXEC"
	.ds.b	2				* S~

device_request_header:
	.ds.l	1
device_strategy:
	move.l	a5,device_request_header
	rts

device_interrupt:
	movem.l	d0/a5,-(sp)
	move.l	device_request_header,a5
	clr.w	d0
	move.b	2(a5),d0
	tst.w	d0
	bne	command_error
	bsr	device_init
device_interrupt_end:
	movem.l	(sp)+,d0/a5
	rts

command_error:
	move.b	#$03,3(a5)
	move.b	#$10,4(a5)
	bra	device_interrupt_end

program_keep_end:

device_init:
	move.l	a1,-(sp)
	bsr	exec_sub

	lea	message_title,a1
	bsr	message_print
	tst.l	d0
	bmi	device_init_error

	lea	filename,a1
	bsr	message_print
	tst.l	d0
	bne	device_init_exec

	lea	message_keep,a1
	bsr	message_print
	bra	@f

device_init_exec:
	lea	message_exec,a1
	bsr	message_print

@@:	move.l	_keep_address,14(a5)
	clr.b	3(a5)
	clr.b	4(a5)
device_init_end:
	move.l	(sp)+,a1
	rts

device_init_error:
	lea	message_error,a1
	bsr	message_print
	move.b	#$0d,3(a5)
	move.b	#$70,4(a5)
	bra	device_init_end

message_print:
	move.l	d0,-(sp)
	tst.b	message_flag
	beq	@f
	IOCS	_B_PRINT
@@:
	move.l	(sp)+,d0
	rts

exec_sub:
	movem.l	d1-d7/a0-a6,-(sp)

* ꎞIɃ|C^ړ
	move.l	$1c20.w,a0
@@:	tst.l	12(a0)
	beq	@f
	move.l	12(a0),a0
	bra	@b
@@:	move.l	a0,_os_memptr
	move.l	8(a0),_os_memend
	move.l	12(a0),_os_next

* fohɃ|C^āAvOs
	move.l	#new_memory_pointer_base,d0
	add.l	#$0000000f,d0
	and.l	#$00fffff0,d0
	move.l	d0,a1
	move.l	a1,_memory_pointer
	move.l	a0,(a1)
	move.l	a0,4(a1)
	lea	16(a1),a3
	move.l	a3,8(a1)
	clr.l	12(a1)
	move.l	a1,8(a0)
	move.l	a1,12(a0)

	lea	filename(pc),a3
	lea	command_line(pc),a4
	move.l	18(a5),a2
@@:
	tst.b	(a2)+
	bne	@b
	tst.b	(a2)
	beq	exec_sub_error

	clr.b	message_flag

	cmp.b	#'-',(a2)
	bne	no_opt
	addq.l	#1,a2
	tst.b	(a2)
	beq	exec_sub_error
@@:
	move.b	(a2)+,d0
	beq	no_opt
	cmp.b	#'v',d0				* bZ[W\
	beq	opt_v
	cmp.b	#'n',d0				* Pss
	beq	opt_n
	bra	@b
opt_v:
	move.b	#1,message_flag
	bra	@b
opt_n:
	lea	message_crlf,a1
	IOCS	_B_PRINT
	bra	@b

no_opt:
	move.l	a3,a0
@@:
	move.b	(a2)+,(a0)+
	bne	@b
	tst.b	(a2)
	beq	@f
	move.b	#' ',-1(a0)
	bra	@b
@@:

	clr.l	-(sp)
	pea	(a4)
	pea	(a3)
	move.w	#2,-(sp)
	DOS	_EXEC			* vOpathT[`
	lea	14(sp),sp
	tst.l	d0
	bmi	exec_sub_error		* Ȃ

	clr.l	-(sp)
	pea	(a4)
	pea	(a3)
	move.w	#1,-(sp)
	DOS	_EXEC			* vO[h
	lea	14(sp),sp
	tst.l	d0
	bmi	exec_sub_error
	move.l	a0,_exec_psp

	movem.l	d1-d7/a0-a6,-(sp)
	pea	(a4)
	move.w	#4,-(sp)
	DOS	_EXEC			* vOs
	lea	6(sp),sp
	movem.l	(sp)+,d1-d7/a0-a6
	tst.l	d0
	bmi	exec_sub_error

	swap.w	d0
	tst.w	d0
	beq	exec_sub_not_keep	* 풓Ȃ...

	move.l	_exec_psp,a0
	move.l	8(a0),_keep_address	* 풓AubN̏I܂
					* fohɊ܂ނ悤ɂ
	clr.l	d0

exec_sub_end:
	move.l	_os_memptr,a0		* |C^Ƃɖ߂
	move.l	_os_memend,8(a0)
	move.l	_os_next,12(a0)

	movem.l	(sp)+,d1-d7/a0-a6
	rts

exec_sub_not_keep:
	move.l	#program_keep_end,_keep_address
	moveq.l	#1,d0
	bra	exec_sub_end

exec_sub_error:
	moveq.l	#-1,d0
	bra	exec_sub_end

start:
	DOS	_EXIT			* ԈċN̂...


message_crlf:
	.dc.b	13,10
	.dc.b	0
message_title:
	.dc.b	13,10
	.dc.b	'devexec v0.1  (c) JACK',13,10
	.dc.b	0
message_exec:
	.dc.b	':s܂B',13,10
	.dc.b	0
message_keep:
	.dc.b	':풓܂B',13,10
	.dc.b	0
message_error:
	.dc.b	'G[ł...',13,10
	.dc.b	0

	.even
_os_memptr:
	.dc.l	0
_os_memend:
	.dc.l	0
_os_next:
	.dc.l	0
_memory_pointer:
	.dc.l	0
_exec_psp:
	.dc.l	0
_keep_address:
	.dc.l	0
message_flag:
	.dc.b	0

	.even
filename:
	.ds.b	256
command_line:
	.ds.b	256

new_memory_pointer_base:

	.end	start
