/* selector.c */

static char rcsid[] = "$Id: selector.c,v 1.2 1994/07/31 16:24:27 JACK Exp $";

#include	<stdio.h>

#include	"cnfsel.h"
#include	"version.h"
#include	"joy_stick.h"
#include	"twin.h"

#ifndef	MAX_LIST
#define	MAX_LIST	1024
#endif

/* IOCS x̃L[̓Tu[`̐錾 */
extern int key_in(void);
extern void key_flush(void);
extern int key_wait(void);

/* j[Xgp\ */
struct menu_list {
	char **menu;
	char **data;
	int max_list;
	int max;
	int offset;
	int pos;
};


/* possڂɔ]o[\ */
void reverse_line(TWIN *win, int pos)
{
	int x, y, xs, ys;
	void *adr;

	if (pos <= win->tymax) {
		x = (win->tx + win->txs + 1) * (win->tfsize / 2);
		y = (win->ty + win->tys + 1 + pos) * win->tfsize;
		xs = (win->txmax+1) * (win->tfsize / 2);
		ys = win->tfsize;
		adr = win->tvram;
		trev3(x, y, xs, ys, adr);
	}
}

/* possڂĕ\ */
int menu_line(TWIN *win, struct menu_list *list, int pos)
{
	twinlocate(win, 0, pos);
	twinprint(win, "\x1b[2K");
	if (list->offset+pos < list->max) {
		twinprint(win, list->menu[list->offset+pos]);
	}
	if (list->offset+pos+1 >= list->max) {
		/* ̃XgȂ */
		return 1;
	}
	return 0;
}

/* XN[͈͂ɃXg\ */
void menu_all(TWIN *win, struct menu_list *list)
{
	int i;

	for (i = 0;i < win->tymax+1; i++) {
		if (menu_line(win, list, i) != 0) {
			if (i < win->tymax) {
				/* ]NA */
				twinlocate(win, 0, i+1);
				twinprint(win, "\x1b[0J");
			}
			break;
		}
	}
	reverse_line(win, list->pos);
}

void page_top(TWIN *win, struct menu_list *list)
{
	if (list->offset+list->pos == 0) {
		/* ߂KvȂ */
		return;
	}

	/* ]o[߂ */
	menu_line(win, list, list->pos);

	/* Sʕ\ */
	list->offset = 0;
	list->pos = 0;
	menu_all(win, list);
}

void page_end(TWIN *win, struct menu_list *list)
{
	if (list->offset+list->pos+1 == list->max) {
		/* ߂KvȂ */
		return;
	}

	/* ]o[߂ */
	menu_line(win, list, list->pos);

	/* Sʕ\ */
	if (list->max >= win->tymax+1) {
		list->offset = list->max - (win->tymax+1);
		list->pos = win->tymax;
	} else {
		/* Sʖ܂Ȃ */
		list->offset = 0;
		list->pos = list->max-1;
	}
	menu_all(win, list);
}

void page_up(TWIN *win, struct menu_list *list)
{
	if (list->offset+(win->tymax+1)+win->tymax >= list->max) {
		/* y[WAbvłȂ̂ōŌɍs */
		page_end(win, list);
		return;
	}

	/* ]o[߂ */
	menu_line(win, list, list->pos);

	/* Sʕ\ */
	list->offset += win->tymax+1;
	menu_all(win, list);
}

void page_down(TWIN *win, struct menu_list *list)
{
	if (list->offset-(win->tymax+1) < 0) {
		/* y[W_EłȂ̂Ő擪ɍs */
		page_top(win, list);
		return;
	}

	/* ]o[߂ */
	menu_line(win, list, list->pos);

	/* Sʕ\ */
	list->offset -= win->tymax+1;
	menu_all(win, list);
}

void roll_up(TWIN *win, struct menu_list *list)
{
	if (list->offset+list->pos+1 >= list->max) {
		/* ̃XgȂ */
		return;
	}

	/* ]o[߂ */
	menu_line(win, list, list->pos);

	/* VKs]o[̕\ */
	if (list->pos+1 <= win->tymax) {
		list->pos++;
	} else {
		/* GXP[vV[PXłPsXN[Abv */
		twinlocate(win, 0, win->tymax);
		twinprint(win, "\x1b""D");

		list->offset++;
		menu_line(win, list, list->pos);
	}
	reverse_line(win, list->pos);
}

void roll_down(TWIN *win, struct menu_list *list)
{
	if (list->offset+list->pos-1 < 0) {
		/* ̃XgȂ */
		return;
	}

	/* ]o[߂ */
	menu_line(win, list, list->pos);

	/* VKs]o[̕\ */
	if (list->pos-1 >= 0) {
		list->pos--;
	} else {
		/* GXP[vV[PXłPsXN[_E */
		twinlocate(win, 0, 0);
		twinprint(win, "\x1b""M");

		list->offset--;
		menu_line(win, list, list->pos);
	}
	reverse_line(win, list->pos);
}


#define	KEY_NULL	0x0000
#define	KEY_RUP		0x0001
#define	KEY_RDOWN	0x0002
#define	KEY_CRUP	0x0101
#define	KEY_CRDOWN	0x0102
#define	KEY_UP		0x0004
#define	KEY_DOWN	0x0008
#define	KEY_LEFT	0x0010
#define	KEY_RIGHT	0x0011
#define	KEY_ESC		0x0020
#define	KEY_RET		0x0021

int selector_key_in(void)
{
	int c, s;

	c = key_in();
	s = _iocs_b_sftsns();

	switch (c) {
	case 0x011b:
		/* ESC */
	case 0x3a00:
		/* UNDO */
		return KEY_ESC;
	case 0x1d0d:
		/* RETURN */
		return KEY_RET;
	case 0x3800:
		/* ROLL UP */
		if (s & 0x02)	return KEY_CRUP;
		return KEY_RUP;
	case 0x3900:
		/* ROLL DOWN */
		if (s & 0x02)	return KEY_CRDOWN;
		return KEY_RDOWN;
	case 0x3b00:
		/*  */
		return KEY_LEFT;
	case 0x3c00:
		/*  */
		return KEY_UP;
	case 0x3d00:
		/* E */
		return KEY_RIGHT;
	case 0x3e00:
		/*  */
		return KEY_DOWN;
	case 0:
		/* ͂Ȃ */
	default:
		return KEY_NULL;
	}
	return KEY_NULL;
}

int selector_joy_in(int joy_no)
{
	int c;

	c = get_joy_stick(joy_no);
	c &= 0xff;
	if (c & JOY_B)		return KEY_ESC;
	if (c & JOY_A)		return KEY_RET;
	switch (c & 0x0f) {
		case JOY_UP:	return KEY_UP;
		case JOY_RUP:	break;
		case JOY_RIGHT:	return KEY_RIGHT;
		case JOY_RDOWN:	break;
		case JOY_DOWN:	return KEY_DOWN;
		case JOY_LDOWN:	break;
		case JOY_LEFT:	return KEY_LEFT;
		case JOY_LUP:	break;
		case JOY_NULL:
		default:		break;
	}
	return KEY_NULL;
}

#define MS_YMAX 128*16

int selector_mouse_in(void)
{
	/* }EẌړ */
	static int ms_y = 0;

	int c;
	char my;
	int myd;

	c = _iocs_ms_getdt();
	if (c & 0x000000ff) return KEY_ESC;
	if (c & 0x0000ff00) return KEY_RET;
	my = (c >> 16) & 0x00ff;
	myd = my;
	if (myd < 0) {
		myd = -myd;
	}
	if ((myd >> 4) == 0) myd = 1;
	myd = myd * my;
	myd = myd + (myd >> 3);
	ms_y += myd;
	if (ms_y > MS_YMAX) {
		ms_y -= MS_YMAX;
		return KEY_DOWN;
	}
	if (ms_y < -(MS_YMAX)) {
		ms_y += MS_YMAX;
		return KEY_UP;
	}
	return KEY_NULL;
}

int jm_key_in(int mode)
{
	int c;

	switch (mode) {
		case 1:
		case 2:
			c = selector_joy_in(mode);
			if (c == KEY_NULL) c = selector_key_in();
			break;
		case 3:
			c = selector_mouse_in();
			if (c == KEY_NULL) c = selector_key_in();
			break;
		case 0:
		default:
			c = selector_key_in();
			break;
	}
	return c;
}

void jm_key_flush(int mode)
{
	switch (mode) {
		case 1:
			key_flush();
			/* gK[̂҂ */
			while ((~_iocs_joyget(0)) & 0x60)
				;
			break;
		case 2:
			key_flush();
			/* gK[̂҂ */
			while ((~_iocs_joyget(1)) & 0x60)
				;
			break;
		case 3:
			key_flush();
			/* }EX{^̂҂ */
			while (_iocs_ms_getdt() & 0x0000ffff)
				;
			break;
		case 0:
		default:
			key_flush();
			break;
	}
}

int read_menu_list(struct menu_list *list, char *file)
{
	static char buffer[MAX_LINE_SIZE+1];
	static char s1[MAX_LINE_SIZE+1];
	static char s2[MAX_LINE_SIZE+1];
	FILE *fp;
	int lines;

	if ((fp = fopen(file, "rt")) == NULL) {
		if (verbose) {
			fprintf(stderr, "%s: t@C %s ܂.\n", progname, file);
		}
		return 0;
	}

	for (lines = 1; list->max < list->max_list; lines++) {
		if (fgets(buffer, MAX_LINE_SIZE, fp) == NULL) break;
		if (buffer[0] == '#' || buffer[0] == '\n') continue;
		if (sscanf(buffer, " \"%[^\"]\" , %[^\n]\n", s1, s2) != 2) {
			if (verbose) {
				fprintf(stderr, "line: %d: tH[}bgsł.\n", lines);
			}
		} else {
			list->menu[list->max] =xstrdup(s1);
			list->data[list->max] =xstrdup(s2);
			list->max++;
		}
	}
	fclose(fp);

	return list->max;
}

char *selector(int mode, char *file)
{
	TWIN *win;
	short x, y, wx = 64, wy = 16;
	short col = 1, fsize = 16;
	short type = WIN_MINT;
	short pcol = 3;
	short tcol = col+0x08;

	static char *menu_list[MAX_LIST];
	static char *config_list[MAX_LIST];
	struct menu_list *list;

	char *config;
	int c;

	list = xmalloc(sizeof(struct menu_list));
	list->menu = menu_list;
	list->data = config_list;
	list->max_list = MAX_LIST;
	list->max = 0;
	list->offset = 0;
	list->pos = 0;

	if (read_menu_list(list, file) == 0) {
		/* XgPLłȂ */
		xfree(list);
		return NULL;
	}

	/* j[XgȂ̓EBhE */
	if (list->max < wy) wy = list->max;

	/* tHgTCYlăZ^O */
	x = (768/(fsize/2)/2) - ((wx+2)/2);
	y = ((16*24)/fsize/2) - ((wy+2)/2);

	/* EBhE|C^mۂ */
	win = twinopen(x, y, wx, wy, col, fsize);
	win->tbufp = xmalloc(twinworksize(win));

	/* EBhE\ */
	twindraw(win, type, "\\CRtBOEXg", tcol);

	/* bZ[W\Fݒ */
	twincolor(win, pcol);

	/* Ƃ肠Sʕ\ */
	menu_all(win, list);

	/* L[̓obt@NA */
	jm_key_flush(mode);

	while (1) {
		c = jm_key_in(mode);
		switch (c) {
			case KEY_ESC:
				/* ESC */
				c = -1;
				goto loop_exit;
			case KEY_RET:
				/* RETURN */
				c = list->offset + list->pos;
				goto loop_exit;

			case KEY_CRUP:
				/* CTRL + ROLL UP */
				jm_key_flush(mode);
				page_end(win, list);
				break;
			case KEY_CRDOWN:
				/* CTRL + ROLL DOWN */
				jm_key_flush(mode);
				page_top(win, list);
				break;

			case KEY_RUP:
				/* ROLL UP */
				jm_key_flush(mode);
				page_up(win, list);
				break;
			case KEY_RDOWN:
				/* ROLL DOWN */
				jm_key_flush(mode);
				page_down(win, list);
				break;

			case KEY_UP:
				/*  */
				jm_key_flush(mode);
				roll_down(win, list);
				break;
			case KEY_DOWN:
				/*  */
				jm_key_flush(mode);
				roll_up(win, list);
				break;

			case KEY_NULL:
			default:
				/* ͂Ȃ */
				break;
		}
	}

/* ESC L[ */
loop_exit:
	if (c >= 0) {
		config = list->data[list->offset+list->pos];
	} else {
		config = NULL;
	}

	/* L[̓obt@NA */
	jm_key_flush(mode);

	/* ]o[߂ */
	menu_line(win, list, list->pos);

	/* n */
	twinclear(win);
	xfree(win->tbufp);
	twinclose(win);

	while (list->max >= 0) {
		list->max--;
		if (list->menu) xfree(list->menu[list->max]);
		if (list->data) xfree(list->data[list->max]);
	}
	xfree(list);
	return config;
}
