/*
 *	sps.h	(sps)
 *		super process
 *
 *		by ici	Dec. 4, 1989
 */

struct Mcb {
    struct Mcb*	prev;
    struct Mcb*	parent;
    long	max;
    struct Mcb*	next;
};

struct BG {
    struct Mcb*	mcb;
    unsigned short id, status, mode, buffersize;
    int		socketaddress;
    char	name[16];
    int		process;
};

struct Process {
    struct Mcb*	mcb;
    long	start, end;
    long	size;
    int		status;
    long	mem;
    int		malloc;
    char*	name;
    struct BG*	bg;
};

struct Device {
    char*	header;
    long	start, end;
    long	size;
    int		status;
    int		atr;
    char	name[32];
};

/* Macros */
#define	KBYTE(x)	(((x)+1023)/1024)
#define	MAX_P		50
#define	MAX_D		50
#define	MAX_B		50
#define	TRUE		1
#define	FALSE		0
#define	P_NORMAL	0
#define	P_KEEP		1
#define	P_MEMDRV	2
#define	P_CHAR		3
#define	P_BLOCK		4
#define	P_HUMAN		5
#define	P_SRAM		6
#define P_SPBLOCK	7
#define	BG_ACTIVE	0
#define	BG_SUSPEND	1
#define	BG_SLEEP	2
#define	BG_ILLEGAL	3
#define	NOPRINT		0
#define	VECPRINT	1
#define	STATUS(x)	(status_name[(x)])

/* External functions */
extern long get_himem_flag (void);	/* spsvec.c */

/* External variables */
extern struct Process	process[MAX_P];
extern struct Device	device[MAX_D];
extern struct BG	bg[MAX_B];
extern int		n_process;
extern int		n_device;
extern int		n_bg;
extern struct Mcb*	top_mcb;
extern long		memory_size;
extern char		printbuf[200];
extern char*		status_name[];
extern char		vector_list[3][0x100][16];

/* Option flags */
extern int	aflag;
extern int	bflag;
extern int	vflag;
extern int	dflag;
extern int	pflag;
extern int	mflag;
extern int	slashflag;
extern char*	processname;

/* EOF */
