/*
 *	spsb.c	(sps)
 *		bg thread table
 *
 *		by ici	Dec. 4, 1989
 */

#include <stdio.h>
#include <string.h>
#include <iocslib.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/dos.h>
#include "sps.h"

/* External functions */
extern int isprocess (struct Mcb*, int*);	/* spsp.c */

/* Structures */
#if 0
struct PRCPTR {
    struct PRCPTR*	next_ptr;
    unsigned char	wait_flg;
    unsigned char	counter;
    unsigned char	max_counter;
    unsigned char	doscmd;
    unsigned long	psp_id;
    unsigned long	usp_reg;
    unsigned long	d_reg[8];
    unsigned long	a_reg[7];
    unsigned short	sr_reg;
    unsigned long	pc_reg;
    unsigned long	ssp_reg;
    unsigned short	indosf;
    unsigned long	indosp;
    struct PRCCTRL*	buf_ptr;
    unsigned char	name[16];
    long		wait_time;
};
#endif
struct BGTHREADTABLE {
    int		address;
    unsigned char	status;
    unsigned char	tmp1;
    unsigned char	mode;
    unsigned char	tmp2;
    struct Mcb*	mcb;
    int		usp;
    int		regs[15];
    short	sr;
    int		pc;
    int		ssp;
    short	tmp3;
    int		tmp4;
    int		socketaddress;
    char	name[16];
    int		counter;
};

/* Macros */
#define	BGSTATUSNAME(x)	(bgstatusname[(x)])

/* File scope variables */
static char* bgstatusname[] = {
    "ACTIVE",
    "SUSPND",
    "SLEEP ",
    "??????"
};

/* Functions */
void
get_bgthread_table (void)
{
    int i, flag, pid;
    struct BGTHREADTABLE buf;
    struct BG* b;

    n_bg = 0;
    flag = _dos_get_pr (0x100 /* LARGE NUMBER but not -1 or -2 */,
			(struct _prcptr*) &buf) & 0xffff;
    if (flag == 0xffff)
	return;

    for (b = bg, i = 0; i < 0x20; i++) {
	long* tmp;

	flag = _dos_get_pr (i, (struct _prcptr*) &buf);
	if (flag & 0xffff0000)
	    continue;

	n_bg++;
	b->mcb = buf.mcb;
	b->id = i & 0xffff;
	b->status = (buf.status == 0x00 ? BG_ACTIVE :
		     buf.status == 0xfe ? BG_SUSPEND :
		     buf.status == 0xff ? BG_SLEEP : BG_ILLEGAL);
	b->mode = buf.mode + 1;
	memcpy (b->name, buf.name, 16);
	b->socketaddress = buf.socketaddress;
	tmp = (long*) buf.socketaddress;
	b->buffersize = *tmp;

	b->process = FALSE;
	if (isprocess (b->mcb, &pid)) {
	    process[pid].bg = b;
	    b->process = TRUE;
	}

	b++;
    }
}

/* Functions */
void
print_bg (struct BG* b)
{
    printf ("%37sID=%02d %s <%s>\n", "",
		b->id, BGSTATUSNAME (b->status), b->name);

#if 0
    if (aflag && vflag) {
	printf ("id %d bgname %16s mcb %06X [%s] mode %d bufsize %04X adr %06X\n",
			b->id,
			b->name,
			b->mcb,
			b->status ? "SLEEP" : "ACTIVE",
			b->mode,
			b->buffersize,
			b->socketaddress
	);
    }
#endif
}

/* EOF */
