/*
 *	spsm.c	(sps)
 *		print memory list
 *
 *		by ici	Dec. 4, 1989
 */

#include <stdio.h>
#include <string.h>
#include "sps.h"

/* Extern functions */
extern int search_and_print_vector (int, long, long, int);	/* spsvec.c */
extern int isprocess (struct Mcb*, int *);	/* spsp.c */

/* Functions */
void
print_memory (void)
{
    struct Mcb* m;

    if (!pflag && !dflag)
	printf ("START___ END_____ SIZE(KB) STATUS COMMAND\n");

    for (m = process[0].mcb; m; m = m->next) {
	int pid;
	int size = m->max - (int) m;

	printf ("%08x %08x %8d ", (unsigned int) m, (unsigned int) m->max - 1,
			KBYTE (size));

	if (isprocess (m, &pid)) {
	    struct Process* p = &process[pid];
	    printf ("%s %s\n", STATUS (p->status), p->name);
	}
	else if (isprocess (m->parent, &pid))
	    printf ("MALLOC  (%s)\n", process[pid].name);
	else
	    printf ("???\n");

	if (vflag)
	    search_and_print_vector (TRUE, (long) m, m->max, m == process[0].mcb);
    }
}

/* EOF */
