/*
 *	veclist.c	(sps)
 *		super process
 *
 *		Copyright (C)1999-2002 Tachibana Eriko
 */

#include "sps.h"

/* Variables */
char vector_list[3][0x100][16] = {
	/* MPU Interrupt */
    { /* 0123456789abcdef */
	"reset (SSP)",		/* 0x00 */
	"reset (PC)",		/* 0x01 */
	"bus error",		/* 0x02 */
	"address error",	/* 0x03 */
	"illegal inst.",	/* 0x04 */
	"divide by zero",	/* 0x05 */
	"CHK",			/* 0x06 */
	"TRAPV",		/* 0x07 */
	"priviledge exc.",	/* 0x08 */
	"trace exception",	/* 0x09 */
	"A-line emulator",	/* 0x0a */
	"F-line emulator",	/* 0x0b */
	"reserved",		/* 0x0c */
	"FPCP protocol er",	/* 0x0d */
	"FPCP format err.",	/* 0x0e */
	"uninitialized",	/* 0x0f */
	"reserved",		/* 0x10 */
	"reserved",		/* 0x11 */
	"reserved",		/* 0x12 */
	"reserved",		/* 0x13 */
	"reserved",		/* 0x14 */
	"reserved",		/* 0x15 */
	"reserved",		/* 0x16 */
	"reserved",		/* 0x17 */
	"spurious",		/* 0x18 */
	"level1 interrupt",	/* 0x19 */
	"level2 interrupt",	/* 0x1a */
	"level3 interrupt",	/* 0x1b */
	"level4 interrupt",	/* 0x1c */
	"level5 interrupt",	/* 0x1d */
	"level6 interrupt",	/* 0x1e */
	"level7 NMI",		/* 0x1f */
	"TRAP0",		/* 0x20 */
	"TRAP1",		/* 0x21 */
	"TRAP2",		/* 0x22 */
	"TRAP3",		/* 0x23 */
	"TRAP4",		/* 0x24 */
	"TRAP5",		/* 0x25 */
	"TRAP6",		/* 0x26 */
	"TRAP7",		/* 0x27 */
	"TRAP8  ROMDB",		/* 0x28 */
	"TRAP9  OS_DB",		/* 0x29 */
	"TRAP10 RESET",		/* 0x2a */
	"TRAP11 BREAK key",	/* 0x2b */
	"TRAP12 COPY key",	/* 0x2c */
	"TRAP13 ^C key",	/* 0x2d */
	"TRAP14 ERROR",		/* 0x2e */
	"TRAP15 IOCS",		/* 0x2f */
	"FPCP unorder",		/* 0x30 */
	"FPCP imprec.",		/* 0x31 */
	"FPCP div by zero",	/* 0x32 */
	"FPCP underflow",	/* 0x33 */
	"FPCP operand err",	/* 0x34 */
	"FPCP overflow",	/* 0x35 */
	"FPCP sig. NaN",	/* 0x36 */
	"FPCP unsupport",	/* 0x37 */
	"PMMU config err",	/* 0x38 */
	"PMMU illegal op",	/* 0x39 */
	"PMMU access lev",	/* 0x3a */
	"reserved",		/* 0x3b */
	"unimp. EA",		/* 0x3c */
	"unimp. Int Inst.",	/* 0x3d */
	"reserved",		/* 0x3e */
	"reserved",		/* 0x3f */

	"MFP RTC ALARM",	/* 0x40 */
	"MFP EXPOFF",		/* 0x41 */
	"MFP POWER SWITCH",	/* 0x42 */
	"MFP OPM TIMER",	/* 0x43 */
	"MFP Timer-D",		/* 0x44 */
	"MFP Timer-C",		/* 0x45 */
	"MFP CRTC V-DISP",	/* 0x46 */
	"MFP (NC)",		/* 0x47 */
	"MFP Timer-B",		/* 0x48 */
	"MFP USART Tx Err",	/* 0x49 */
	"MFP USART Tx Emp",	/* 0x4a */
	"MFP Rx Error",		/* 0x4b */
	"MFP Rx BufFull",	/* 0x4c */
	"MFP Timer-A",		/* 0x4d */
	"MFP CRTC IRQ",		/* 0x4e */
	"MFP CRTC H-SYNC",	/* 0x4f */
	"SCCB TxBufEmpty",	/* 0x50 */
	"SCCB TxBufEmpty",	/* 0x51 */
	"SCCB ChgStatus",	/* 0x52 */
	"SCCB ChgStatus",	/* 0x53 */
	"SCCB Rx",		/* 0x54 */
	"SCCB Rx",		/* 0x55 */
	"SCCB RxSpecial",	/* 0x56 */
	"SCCB RxSpecial",	/* 0x57 */
	"SCCA TxBufEmpty",	/* 0x58 */
	"SCCA TxBufEmpty",	/* 0x59 */
	"SCCA ChgStatus",	/* 0x5a */
	"SCCA ChgStatus",	/* 0x5b */
	"SCCA Rx",		/* 0x5c */
	"SCCA Rx",		/* 0x5d */
	"SCCA RxSpecial",	/* 0x5e */
	"SCCA RxSpecial",	/* 0x5f */
	"FDCINT",		/* 0x60 */
	"FDDINT Ins/Eject",	/* 0x61 */
	"HDCINT",		/* 0x62 */
	"PRNINT",		/* 0x63 */
	"DMAC ch.0 normal",	/* 0x64 */
	"DMAC ch.0 error",	/* 0x65 */
	"DMAC ch.1 normal",	/* 0x66 */
	"DMAC ch.1 error",	/* 0x67 */
	"DMAC ch.2 normal",	/* 0x68 */
	"DMAC ch.2 error",	/* 0x69 */
	"DMAC ch.3 normal",	/* 0x6a */
	"DMAC ch.3 error",	/* 0x6b */
	"SCSIIN SPC",		/* 0x6c */
	"",			/* 0x6d */
	"",			/* 0x6e */
	"",			/* 0x6f */
	"",			/* 0x70 */
	"",			/* 0x71 */
	"",			/* 0x72 */
	"",			/* 0x73 */
	"",			/* 0x74 */
	"",			/* 0x75 */
	"",			/* 0x76 */
	"",			/* 0x77 */
	"",			/* 0x78 */
	"",			/* 0x79 */
	"",			/* 0x7a */
	"",			/* 0x7b */
	"",			/* 0x7c */
	"",			/* 0x7d */
	"",			/* 0x7e */
	"",			/* 0x7f */
	"MIDI #0",		/* 0x80 */
	"MIDI #0",		/* 0x81 */
	"MIDI #0",		/* 0x82 */
	"MIDI #0",		/* 0x83 */
	"MIDI #0",		/* 0x84 */
	"MIDI #0",		/* 0x85 */
	"MIDI #0",		/* 0x86 */
	"MIDI #0",		/* 0x87 */
	"MIDI #0",		/* 0x88 */
	"MIDI #0",		/* 0x89 */
	"MIDI #0",		/* 0x8a */
	"MIDI #0",		/* 0x8b */
	"MIDI #0",		/* 0x8c */
	"MIDI #0",		/* 0x8d */
	"MIDI #0",		/* 0x8e */
	"MIDI #0",		/* 0x8f */
	"",			/* 0x90 */
	"",			/* 0x91 */
	"",			/* 0x92 */
	"",			/* 0x93 */
	"",			/* 0x94 */
	"",			/* 0x95 */
	"",			/* 0x96 */
	"",			/* 0x97 */
	"",			/* 0x98 */
	"",			/* 0x99 */
	"",			/* 0x9a */
	"",			/* 0x9b */
	"",			/* 0x9c */
	"",			/* 0x9d */
	"",			/* 0x9e */
	"",			/* 0x9f */
	"MIDI #1",		/* 0xa0 */
	"MIDI #1",		/* 0xa1 */
	"MIDI #1",		/* 0xa2 */
	"MIDI #1",		/* 0xa3 */
	"MIDI #1",		/* 0xa4 */
	"MIDI #1",		/* 0xa5 */
	"MIDI #1",		/* 0xa6 */
	"MIDI #1",		/* 0xa7 */
	"MIDI #1",		/* 0xa8 */
	"MIDI #1",		/* 0xa9 */
	"MIDI #1",		/* 0xaa */
	"MIDI #1",		/* 0xab */
	"MIDI #1",		/* 0xac */
	"MIDI #1",		/* 0xad */
	"MIDI #1",		/* 0xae */
	"MIDI #1",		/* 0xaf */
	"RC-232C #0 ch.B",	/* 0xb0 */
	"RC-232C #0 ch.B",	/* 0xb1 */
	"RC-232C #0 ch.B",	/* 0xb2 */
	"RC-232C #0 ch.B",	/* 0xb3 */
	"RC-232C #0 ch.B",	/* 0xb4 */
	"RC-232C #0 ch.B",	/* 0xb5 */
	"RC-232C #0 ch.B",	/* 0xb6 */
	"RC-232C #0 ch.B",	/* 0xb7 */
	"RC-232C #0 ch.A",	/* 0xb8 */
	"RC-232C #0 ch.A",	/* 0xb9 */
	"RC-232C #0 ch.A",	/* 0xba */
	"RC-232C #0 ch.A",	/* 0xbb */
	"RC-232C #0 ch.A",	/* 0xbc */
	"RC-232C #0 ch.A",	/* 0xbd */
	"RC-232C #0 ch.A",	/* 0xbe */
	"RC-232C #0 ch.A",	/* 0xbf */
	"RC-232C #1 ch.B",	/* 0xc0 */
	"RC-232C #1 ch.B",	/* 0xc1 */
	"RC-232C #1 ch.B",	/* 0xc2 */
	"RC-232C #1 ch.B",	/* 0xc3 */
	"RC-232C #1 ch.B",	/* 0xc4 */
	"RC-232C #1 ch.B",	/* 0xc5 */
	"RC-232C #1 ch.B",	/* 0xc6 */
	"RC-232C #1 ch.B",	/* 0xc7 */
	"RC-232C #1 ch.A",	/* 0xc8 */
	"RC-232C #1 ch.A",	/* 0xc9 */
	"RC-232C #1 ch.A",	/* 0xca */
	"RC-232C #1 ch.A",	/* 0xcb */
	"RC-232C #1 ch.A",	/* 0xcc */
	"RC-232C #1 ch.A",	/* 0xcd */
	"RC-232C #1 ch.A",	/* 0xce */
	"RC-232C #1 ch.A",	/* 0xcf */
	"",			/* 0xd0 */
	"",			/* 0xd1 */
	"",			/* 0xd2 */
	"",			/* 0xd3 */
	"",			/* 0xd4 */
	"",			/* 0xd5 */
	"",			/* 0xd6 */
	"",			/* 0xd7 */
	"",			/* 0xd8 */
	"",			/* 0xd9 */
	"",			/* 0xda */
	"",			/* 0xdb */
	"",			/* 0xdc */
	"",			/* 0xdd */
	"",			/* 0xde */
	"",			/* 0xdf */
	"",			/* 0xe0 */
	"",			/* 0xe1 */
	"",			/* 0xe2 */
	"",			/* 0xe3 */
	"",			/* 0xe4 */
	"",			/* 0xe5 */
	"",			/* 0xe6 */
	"",			/* 0xe7 */
	"",			/* 0xe8 */
	"",			/* 0xe9 */
	"",			/* 0xea */
	"",			/* 0xeb */
	"",			/* 0xec */
	"",			/* 0xed */
	"",			/* 0xee */
	"",			/* 0xef */
	"PSX16x50 receive",	/* 0xf0 */
	"",			/* 0xf1 */
	"",			/* 0xf2 */
	"",			/* 0xf3 */
	"",			/* 0xf4 */
	"",			/* 0xf5 */
	"SCSIEX SPC",		/* 0xf6 */
	"TS-6BSI PPI",		/* 0xf7 */
	"Nereid #1 Ether",	/* 0xf8 */
	"Nereid #0 Ether",	/* 0xf9 */	/* Neptune-X/Evolution */
	"Nereid #1 USB",	/* 0xfa */
	"Nereid #0 USB",	/* 0xfb */	/* GP-IB */
	"Univ.I/O #0",		/* 0xfc */
	"Univ.I/O #1",		/* 0xfd */
	"Univ.I/O #2",		/* 0xfe */
	"M-U V4 OPNA",		/* 0xff */	/* Univ.I/O #3 */
    },

	/* IOCS call */
    { /* 0123456789abcdef */
	"_B_KEYINP",		/* 0x00 */
	"_B_KEYSNS",		/* 0x01 */
	"_B_SFTSNS",		/* 0x02 */
	"_KEY_INIT",		/* 0x03 */
	"_BITSNS",		/* 0x04 */
	"_SKEYSET",		/* 0x05 */
	"_LEDCTRL",		/* 0x06 */
	"_LEDSET",		/* 0x07 */
	"_KEYDLY",		/* 0x08 */
	"_KEYREP",		/* 0x09 */
	"_OPT2EN",		/* 0x0a */
	"_OPT2DIS",		/* 0x0b */
	"_TVCTRL",		/* 0x0c */
	"_LEDMOD",		/* 0x0d */
	"_TGUSEMD",		/* 0x0e */
	"_DEFCHR",		/* 0x0f */
	"_CRTMOD",		/* 0x10 */
	"_CONTRAST",		/* 0x11 */
	"_HSVTORGB",		/* 0x12 */
	"_TPALET",		/* 0x13 */
	"_TPALET2",		/* 0x14 */
	"_TCOLOR",		/* 0x15 */
	"_FNTADR",		/* 0x16 */
	"_VRAMGET",		/* 0x17 */
	"_VRAMPUT",		/* 0x18 */
	"_FNTGET",		/* 0x19 */
	"_TEXTGET",		/* 0x1a */
	"_TEXTPUT",		/* 0x1b */
	"_CLIPPUT",		/* 0x1c */
	"_SCROLL",		/* 0x1d */
	"_B_CURON",		/* 0x1e */
	"_B_CUROFF",		/* 0x1f */
	"_B_PUTC",		/* 0x20 */
	"_B_PRINT",		/* 0x21 */
	"_B_COLOR",		/* 0x22 */
	"_B_LOCATE",		/* 0x23 */
	"_B_DOWN_S",		/* 0x24 */
	"_B_UP_S",		/* 0x25 */
	"_B_UP",		/* 0x26 */
	"_B_DOWN",		/* 0x27 */
	"_B_RIGHT",		/* 0x28 */
	"_B_LEFT",		/* 0x29 */
	"_B_CLR_ST",		/* 0x2a */
	"_B_ERA_ST",		/* 0x2b */
	"_B_INS",		/* 0x2c */
	"_B_DEL",		/* 0x2d */
	"_B_CONSOL",		/* 0x2e */
	"_B_PUTMES",		/* 0x2f */
	"_SET232C",		/* 0x30 */
	"_LOF232C",		/* 0x31 */
	"_INP232C",		/* 0x32 */
	"_ISNS232C",		/* 0x33 */
	"_OSNS232C",		/* 0x34 */
	"_OUT232C",		/* 0x35 */
	"_SETMSADR",		/* 0x36 */
	"_SETESCADR",		/* 0x37 */
	"_SETFNTADR",		/* 0x38 */
	"_SET_BEEP",		/* 0x39 */
	"_SET_PRN",		/* 0x3a */
	"_JOYGET",		/* 0x3b */
	"_INIT_PRN",		/* 0x3c */
	"_SNSPRN",		/* 0x3d */
	"_OUTLPT",		/* 0x3e */
	"_OUTPRN",		/* 0x3f */
	"_B_SEEK",		/* 0x40 */
	"_B_VERIFY",		/* 0x41 */
	"_B_READDI",		/* 0x42 */
	"_B_DSKINI",		/* 0x43 */
	"_B_DRVSNS",		/* 0x44 */
	"_B_WRITE",		/* 0x45 */
	"_B_READ",		/* 0x46 */
	"_B_RECALI",		/* 0x47 */
	"_B_ASSIGN",		/* 0x48 */
	"_B_WRITED",		/* 0x49 */
	"_B_READID",		/* 0x4a */
	"_B_BADFMT",		/* 0x4b */
	"_B_READDL",		/* 0x4c */
	"_B_FORMAT",		/* 0x4d */
	"_B_DRVCHK",		/* 0x4e */
	"_B_EJECT",		/* 0x4f */
	"_DATEBCD",		/* 0x50 */
	"_DATESET",		/* 0x51 */
	"_TIMEBCD",		/* 0x52 */
	"_TIMESET",		/* 0x53 */
	"_DATEGET",		/* 0x54 */
	"_DATEBIN",		/* 0x55 */
	"_TIMEGET",		/* 0x56 */
	"_TIMEBIN",		/* 0x57 */
	"_DATECNV",		/* 0x58 */
	"_TIMECNV",		/* 0x59 */
	"_DATEASC",		/* 0x5a */
	"_TIMEASC",		/* 0x5b */
	"_DAYASC",		/* 0x5c */
	"_ALARMMOD",		/* 0x5d */
	"_ALARMSET",		/* 0x5e */
	"_ALARMGET",		/* 0x5f */
	"_ADPCMOUT",		/* 0x60 */
	"_ADPCMINP",		/* 0x61 */
	"_ADPCMAOT",		/* 0x62 */
	"_ADPCMAIN",		/* 0x63 */
	"_ADPCMLOT",		/* 0x64 */
	"_ADPCMLIN",		/* 0x65 */
	"_ADPCMSNS",		/* 0x66 */
	"_ADPCMMOD",		/* 0x67 */
	"_OPMSET",		/* 0x68 */
	"_OPMSNS",		/* 0x69 */
	"_OPMINTST",		/* 0x6a */
	"_TIMERDST",		/* 0x6b */
	"_TIMERAST",		/* 0x6c */
	"_CRTCRAS",		/* 0x6d */
	"_HSYNCST",		/* 0x6e */
	"_PRNINTST",		/* 0x6f */
	"_MS_INIT",		/* 0x70 */
	"_MS_CURON",		/* 0x71 */
	"_MS_CUROF",		/* 0x72 */
	"_MS_STAT",		/* 0x73 */
	"_MS_GETDT",		/* 0x74 */
	"_MS_CURGT",		/* 0x75 */
	"_MS_CURST",		/* 0x76 */
	"_MS_LIMIT",		/* 0x77 */
	"_MS_OFFTM",		/* 0x78 */
	"_MS_ONTM",		/* 0x79 */
	"_MS_PATST",		/* 0x7a */
	"_MS_SEL",		/* 0x7b */
	"_MS_SEL2",		/* 0x7c */
	"_SKEY_MOD",		/* 0x7d */
	"_DENSNS",		/* 0x7e */
	"_ONTIME",		/* 0x7f */
	"_B_INTVCS",		/* 0x80 */
	"_B_SUPER",		/* 0x81 */
	"_B_BPEEK",		/* 0x82 */
	"_B_WPEEK",		/* 0x83 */
	"_B_LPEEK",		/* 0x84 */
	"_B_MEMSTR",		/* 0x85 */
	"_B_BPOKE",		/* 0x86 */
	"_B_WPOKE",		/* 0x87 */
	"_B_LPOKE",		/* 0x88 */
	"_B_MEMSET",		/* 0x89 */
	"_DMAMOVE",		/* 0x8a */
	"_DMAMOV_A",		/* 0x8b */
	"_DMAMOV_L",		/* 0x8c */
	"_DMAMODE",		/* 0x8d */
	"_BOOTINF",		/* 0x8e */
	"_ROMVER",		/* 0x8f */
	"_G_CLR_ON",		/* 0x90 */
	"_VC_R0",		/* 0x91 */
	"_VC_R1",		/* 0x92 */
	"_VC_R2",		/* 0x93 */
	"_GPALET",		/* 0x94 */
	"_GCOLOR",		/* 0x95 */
	"_APAGE2",		/* 0x96 */
	"_GVRAMGET",		/* 0x97 */
	"_GVRAMPUT2",		/* 0x98 */
	"_GVRAMPUT",		/* 0x99 */
	"_GBITPUT",		/* 0x9a */
	"_GBITPUT2",		/* 0x9b */
	"_GBITPUT3",		/* 0x9c */
	"",			/* 0x9d */
	"",			/* 0x9e */
	"",			/* 0x9f */
	"_SFTJIS",		/* 0xa0 */
	"_JISSFT",		/* 0xa1 */
	"_AKCONV",		/* 0xa2 */
	"_RMACNV",		/* 0xa3 */
	"_DAKJOB",		/* 0xa4 */
	"_HANJOB",		/* 0xa5 */
	"",			/* 0xa6 */
	"",			/* 0xa7 */
	"",			/* 0xa8 */
	"",			/* 0xa9 */
	"",			/* 0xaa */
	"",			/* 0xab */
	"_SYS_STAT",		/* 0xac */
	"_B_CONMOD",		/* 0xad */
	"_OS_CURON",		/* 0xae */
	"_OS_CUROF",		/* 0xaf */
	"_DRAWMODE",		/* 0xb0 */
	"_APAGE",		/* 0xb1 */
	"_VPAGE",		/* 0xb2 */
	"_HOME",		/* 0xb3 */
	"_WINDOW",		/* 0xb4 */
	"_WIPE",		/* 0xb5 */
	"_PSET",		/* 0xb6 */
	"_POINT",		/* 0xb7 */
	"_LINE",		/* 0xb8 */
	"_BOX",			/* 0xb9 */
	"_FILL",		/* 0xba */
	"_CIRCLE",		/* 0xbb */
	"_PAINT",		/* 0xbc */
	"_SYMBOL",		/* 0xbd */
	"_GETGRM",		/* 0xbe */
	"_PUTGRM",		/* 0xbf */
	"_SP_INIT",		/* 0xc0 */
	"_SP_ON",		/* 0xc1 */
	"_SP_OFF",		/* 0xc2 */
	"_SP_CGCLR",		/* 0xc3 */
	"_SP_DEFCG",		/* 0xc4 */
	"_SP_GTPCG",		/* 0xc5 */
	"_SP_REGST",		/* 0xc6 */
	"_SP_REGGT",		/* 0xc7 */
	"_BGSCRLST",		/* 0xc8 */
	"_BGSCRLGT",		/* 0xc9 */
	"_BGCTRLST",		/* 0xca */
	"_BGCTRLGT",		/* 0xcb */
	"_BGTEXTCL",		/* 0xcc */
	"_BGTEXTST",		/* 0xcd */
	"_BGTEXTGT",		/* 0xce */
	"_SPALET",		/* 0xcf */
	"_MACS",		/* 0xd0 */	/* macsdrv.x */
	"_MOON",		/* 0xd1 */	/* moon.x */
	"",			/* 0xd2 */
	"_TXXLINE",		/* 0xd3 */
	"_TXYLINE",		/* 0xd4 */
	"_TXLINE",		/* 0xd5 */
	"_TXBOX",		/* 0xd6 */
	"_TXFILL",		/* 0xd7 */
	"_TXREV",		/* 0xd8 */
	"",			/* 0xd9 */
	"",			/* 0xda */
	"",			/* 0xdb */
	"",			/* 0xdc */
	"",			/* 0xdd */
	"",			/* 0xde */
	"_TXRASCPY",		/* 0xdf */
	"",			/* 0xe0 */
	"",			/* 0xe1 */
	"",			/* 0xe2 */
	"",			/* 0xe3 */
	"",			/* 0xe4 */
	"",			/* 0xe5 */
	"",			/* 0xe6 */
	"",			/* 0xe7 */
	"",			/* 0xe8 */
	"",			/* 0xe9 */
	"",			/* 0xea */
	"",			/* 0xeb */
	"",			/* 0xec */
	"",			/* 0xed */
	"",			/* 0xee */
	"",			/* 0xef */
	"_OPMDRV",		/* 0xf0 */	/* OPMDRV.X */
	"_RSDRV",		/* 0xf1 */	/* RSDRV.SYS */
	"_A_JOYGET",		/* 0xf2 */	/* AJOY.X */
	"_MUSICDRV",		/* 0xf3 */	/* MUSICDRV.X */
	"_MERCURY",		/* 0xf4 */	/* mercurydriver.sys */
	"_SCSIDRV",		/* 0xf5 */
	"",			/* 0xf6 */
	"",			/* 0xf7 */
	"_HIMEM",		/* 0xf8 */	/* himem.sys, etc. */
	"_TS6BGAG",		/* 0xf9 */	/* ts6bgag.x */
	"_TS6BGAS",		/* 0xfa */	/* ts6bgas.x */
	"",			/* 0xfb */
	"",			/* 0xfc */
	"_ABORTRST",		/* 0xfd */
	"_IPLERR",		/* 0xfe */
	"_ABORTJOB",		/* 0xff */
    },

	/* DOS call */
    { /* 0123456789abcdef */
	"_EXIT",		/* 0x00 */
	"_GETCHAR",		/* 0x01 */
	"_PUTCHAR",		/* 0x02 */
	"_COMINP",		/* 0x03 */
	"_COMOUT",		/* 0x04 */
	"_PRNOUT",		/* 0x05 */
	"_INPOUT",		/* 0x06 */
	"_INKEY",		/* 0x07 */
	"_GETC",		/* 0x08 */
	"_PRINT",		/* 0x09 */
	"_GETS",		/* 0x0a */
	"_KEYSNS",		/* 0x0b */
	"_KFLUSH",		/* 0x0c */
	"_FFLUSH",		/* 0x0d */
	"_CHGDRV",		/* 0x0e */
	"_DRVCTRL",		/* 0x0f */
	"_CONSNS",		/* 0x10 */
	"_PRNSNS",		/* 0x11 */
	"_CINSNS",		/* 0x12 */
	"_COUTSNS",		/* 0x13 */
	"",			/* 0x14 */
	"",			/* 0x15 */
	"",			/* 0x16 */
	"_FATCHK",		/* 0x17 */
	"_HENDSP",		/* 0x18 */
	"_CURDRV",		/* 0x19 */
	"_GETSS",		/* 0x1a */
	"_FGETC",		/* 0x1b */
	"_FGETS",		/* 0x1c */
	"_FPUTC",		/* 0x1d */
	"_FPUTS",		/* 0x1e */
	"_ALLCLOSE",		/* 0x1f */
	"_SUPER",		/* 0x20 */
	"_FNCKEY",		/* 0x21 */
	"_KNJCTRL",		/* 0x22 */
	"_CONCTRL",		/* 0x23 */
	"_KEYCTRL",		/* 0x24 */
	"_INTVCS",		/* 0x25 */
	"_MAKEPSP",		/* 0x26 */
	"_GETTIM2",		/* 0x27 */
	"_SETTIM2",		/* 0x28 */
	"_NAMESTS",		/* 0x29 */
	"_GETDATE",		/* 0x2a */
	"_SETDATE",		/* 0x2b */
	"_GETTIME",		/* 0x2c */
	"_SETTIME",		/* 0x2d */
	"_VERIFY",		/* 0x2e */
	"_DUP0",		/* 0x2f */
	"_VERNUM",		/* 0x30 */
	"_KEEPPR",		/* 0x31 */
	"_GETDPB",		/* 0x32 */
	"_BREAKCK",		/* 0x33 */
	"_DRVXCHG",		/* 0x34 */
	"_INTVCG",		/* 0x35 */
	"_DSKFRE",		/* 0x36 */
	"_NAMECK",		/* 0x37 */
	"",			/* 0x38 */
	"_MKDIR",		/* 0x39 */
	"_RMDIR",		/* 0x3a */
	"_CHDIR",		/* 0x3b */
	"_CREATE",		/* 0x3c */
	"_OPEN",		/* 0x3d */
	"_CLOSE",		/* 0x3e */
	"_READ",		/* 0x3f */
	"_WRITE",		/* 0x40 */
	"_DELETE",		/* 0x41 */
	"_SEEK",		/* 0x42 */
	"_CHMOD",		/* 0x43 */
	"_IOCTRL",		/* 0x44 */
	"_DUP",			/* 0x45 */
	"_DUP2",		/* 0x46 */
	"_CURDIR",		/* 0x47 */
	"_MALLOC",		/* 0x48 */
	"_MFREE",		/* 0x49 */
	"_SETBLOCK",		/* 0x4a */
	"_EXEC",		/* 0x4b */
	"_EXIT2",		/* 0x4c */
	"_WAIT",		/* 0x4d */
	"_FILES",		/* 0x4e */
	"_NFILES",		/* 0x4f */
	"_V2_SETPSP",		/* 0x50 */
	"_V2_GETPSP",		/* 0x51 */
	"_V2_SETENV",		/* 0x52 */
	"_V2_GETENV",		/* 0x53 */
	"_V2_VERIFYG",		/* 0x54 */
	"_V2_COMMON",		/* 0x55 */
	"_V2_RENAME",		/* 0x56 */
	"_V2_FILEDATE",		/* 0x57 */
	"_V2_MALLOC2",		/* 0x58 */
	"",			/* 0x59 */
	"_V2_MAKETMP",		/* 0x5a */
	"_V2_NEWFILE",		/* 0x5b */
	"_V2_LOCK",		/* 0x5c */
	"",			/* 0x5d */
	"",			/* 0x5e */
	"_V2_ASSIGN",		/* 0x5f */
	"_V2_MALLOC3",		/* 0x60 */	/* 060turbo.sys */
	"_V2_SETBLOCK2",	/* 0x61 */	/* 060turbo.sys */
	"_V2_MALLOC4",		/* 0x62 */	/* 060turbo.sys */
	"_V2_S_MALLOC2",	/* 0x63 */	/* 060turbo.sys */
	"",			/* 0x64 */
	"",			/* 0x65 */
	"",			/* 0x66 */
	"",			/* 0x67 */
	"",			/* 0x68 */
	"",			/* 0x69 */
	"",			/* 0x6a */
	"",			/* 0x6b */
	"",			/* 0x6c */
	"",			/* 0x6d */
	"",			/* 0x6e */
	"",			/* 0x6f */
	"",			/* 0x70 */
	"",			/* 0x71 */
	"",			/* 0x72 */
	"",			/* 0x73 */
	"",			/* 0x74 */
	"",			/* 0x75 */
	"",			/* 0x76 */
	"",			/* 0x77 */
	"",			/* 0x78 */
	"",			/* 0x79 */
	"_V2_FFLUSH_SET",	/* 0x7a */
	"_V2_OS_PATCH",		/* 0x7b */
	"_V2_GETFCB",		/* 0x7c */
	"_V2_S_MALLOC",		/* 0x7d */
	"_V2_S_MFREE",		/* 0x7e */
	"_V2_S_PROCESS",	/* 0x7f */
	"_SETPSP",		/* 0x80 */
	"_GETPSP",		/* 0x81 */
	"_SETENV",		/* 0x82 */
	"_GETENV",		/* 0x83 */
	"_VERIFYG",		/* 0x84 */
	"_COMMON",		/* 0x85 */
	"_RENAME",		/* 0x86 */
	"_FILEDATE",		/* 0x87 */
	"_MALLOC2",		/* 0x88 */
	"",			/* 0x89 */
	"_MAKETMP",		/* 0x8a */
	"_NEWFILE",		/* 0x8b */
	"_LOCK",		/* 0x8c */
	"",			/* 0x8d */
	"",			/* 0x8e */
	"_ASSIGN",		/* 0x8f */
	"_MALLOC3",		/* 0x90 */	/* 060turbo.sys */
	"_SETBLOCK2",		/* 0x91 */	/* 060turbo.sys */
	"_MALLOC4",		/* 0x92 */	/* 060turbo.sys */
	"_S_MALLOC2",		/* 0x93 */	/* 060turbo.sys */
	"",			/* 0x94 */
	"",			/* 0x95 */
	"",			/* 0x96 */
	"",			/* 0x97 */
	"",			/* 0x98 */
	"",			/* 0x99 */
	"",			/* 0x9a */
	"",			/* 0x9b */
	"",			/* 0x9c */
	"",			/* 0x9d */
	"",			/* 0x9e */
	"",			/* 0x9f */
	"",			/* 0xa0 */
	"",			/* 0xa1 */
	"",			/* 0xa2 */
	"",			/* 0xa3 */
	"",			/* 0xa4 */
	"",			/* 0xa5 */
	"",			/* 0xa6 */
	"",			/* 0xa7 */
	"",			/* 0xa8 */
	"",			/* 0xa9 */
	"_FFLUSH_SET",		/* 0xaa */
	"_OS_PATCH",		/* 0xab */
	"_GETFCB",		/* 0xac */
	"_S_MALLOC",		/* 0xad */
	"_S_MFREE",		/* 0xae */
	"_S_PROCESS",		/* 0xaf */
	"_TWON",		/* 0xb0 */	/* (V)TwentyOne.sys */
	"_MVDIR",		/* 0xb1 */	/* dos_mvdir.r */
	"",			/* 0xb2 */
	"",			/* 0xb3 */
	"",			/* 0xb4 */
	"",			/* 0xb5 */
	"",			/* 0xb6 */
	"",			/* 0xb7 */
	"",			/* 0xb8 */
	"",			/* 0xb9 */
	"",			/* 0xba */
	"",			/* 0xbb */
	"",			/* 0xbc */
	"",			/* 0xbd */
	"",			/* 0xbe */
	"",			/* 0xbf */
	"",			/* 0xc0 */
	"",			/* 0xc1 */
	"",			/* 0xc2 */
	"",			/* 0xc3 */
	"",			/* 0xc4 */
	"",			/* 0xc5 */
	"",			/* 0xc6 */
	"",			/* 0xc7 */
	"",			/* 0xc8 */
	"",			/* 0xc9 */
	"",			/* 0xca */
	"",			/* 0xcb */
	"",			/* 0xcc */
	"",			/* 0xcd */
	"",			/* 0xce */
	"",			/* 0xcf */
	"",			/* 0xd0 */
	"",			/* 0xd1 */
	"",			/* 0xd2 */
	"",			/* 0xd3 */
	"",			/* 0xd4 */
	"",			/* 0xd5 */
	"",			/* 0xd6 */
	"",			/* 0xd7 */
	"",			/* 0xd8 */
	"",			/* 0xd9 */
	"",			/* 0xda */
	"",			/* 0xdb */
	"",			/* 0xdc */
	"",			/* 0xdd */
	"",			/* 0xde */
	"",			/* 0xdf */
	"_VMALLOC",		/* 0xe0 */	/* swapper.sys */
	"_VMFREE",		/* 0xe1 */	/* swapper.sys */
	"_VMALLOC2",		/* 0xe2 */	/* swapper.sys */
	"_VSETBLOCK",		/* 0xe3 */	/* swapper.sys */
	"_VEXEC",		/* 0xe4 */	/* vmexec.sys */
	"",			/* 0xe5 */
	"",			/* 0xe6 */
	"",			/* 0xe7 */
	"",			/* 0xe8 */
	"",			/* 0xe9 */
	"",			/* 0xea */
	"",			/* 0xeb */
	"",			/* 0xec */
	"",			/* 0xed */
	"",			/* 0xee */
	"_GETFONT",		/* 0xef */	/* fontman.x */
	"_EXITVC",		/* 0xf0 */
	"_CTRLVC",		/* 0xf1 */
	"_ERRJVC",		/* 0xf2 */
	"_DISKRED",		/* 0xf3 */
	"_DISKWRT",		/* 0xf4 */
	"_INDOSFLG",		/* 0xf5 */
	"_SUPER_JSR",		/* 0xf6 */
	"_BUS_ERR",		/* 0xf7 */
	"_OPEN_PR",		/* 0xf8 */
	"_KILL_PR",		/* 0xf9 */
	"_GET_PR",		/* 0xfa */
	"_SUSPEND_PR",		/* 0xfb */
	"_SLEEP_PR",		/* 0xfc */
	"_SEND_PR",		/* 0xfd */
	"_TIME_PR",		/* 0xfe */
	"_CHANGE_PR",		/* 0xff */
    }
};

/* EOF */
